﻿<html>
<head>
	<title>Inserimento lezione</title>
</head>

<body>
	<?php
		// -------------------------------------------------------
		// controllo della presenza dei parametri
		if(!isset($_REQUEST["codfisc"]) or
			!isset($_REQUEST["giorno"]) or
			!isset($_REQUEST["orainizio"]) or
			!isset($_REQUEST["durata"]) or
			!isset($_REQUEST["codc"]) or
			!isset($_REQUEST["sala"])) 
			die("Errore: inserire tutti i dati richiesti");
		// -------------------------------------------------------
		// acquisizione dei parametri
		$codfisc = $_REQUEST["codfisc"];
		$giorno = $_REQUEST["giorno"];
		$orainizio = $_REQUEST["orainizio"];
		$timeinizio = strtotime($orainizio);
		$durata = $_REQUEST["durata"];
		$codc = $_REQUEST["codc"];
		$sala = $_REQUEST["sala"];
		// -------------------------------------------------------
		// controllo iniziale della validità dei parametri
		if($giorno != "Lunedì" and $giorno != "Martedì" and $giorno != "Mercoledì" and $giorno != "Giovedì" and $giorno != "Venerdì")
		   die("Errore: il giorno specificato non è valido");
		if(empty($timeinizio) or empty($durata))
		   die("Errore: l'ora di inizio e/o la durata non sono valide");
		if($durata > 60)
		  die("Errore: Le lezioni non possono durare più di 60 minuti");
		if(empty($sala))
			die("Errore:la sala non è definita");
		// -------------------------------------------------------
		// connessione al DB
		$con = mysqli_connect('localhost','root','','palestra');
		if (mysqli_connect_errno())
			echo "Failed to connect to MySQL: " . mysqli_connect_error();
		mysqli_query($con, "SET CHARACTER SET utf8");
		mysqli_query($con, "SET NAMES utf8");
		// -------------------------------------------------------
		// esecuzione di
	  //  . query per verificare che la sala o l'istruttore indicati non siano già occupati
	  //  . query per inserire la lezione
		//  controllo per verificare l'occupazione della sala o dell'istruttore
		$orafine = date('H:i', strtotime("+ $durata minutes", strtotime($orainizio)));
		$overlap = "((OraInizio <= '$orafine') and (DATE_ADD(OraInizio, INTERVAL Durata MINUTE) >= '$orainizio'))";
		$sql  = "SELECT count(*)
			FROM programma 
			where ((Sala = '$sala') or (CodFisc = '$codfisc')) and Giorno = '$giorno' and " . $overlap;
			$result = mysqli_query($con,$sql);
		if(!$result)
			die('Query error: ' . mysqli_error($con));
		$row = mysqli_fetch_row($result);
		if($row[0] > 0)
			Echo "Errore: la sala e/o l'istruttore indicati sono già occupati nell'orario selezionato<br>";
		else {
			// inserimento della lezione e visualizzazione del risultato
			$sql = "INSERT INTO Programma (CodFisc, Giorno, OraInizio, Durata, CodC, Sala) 
				VALUES ('$codfisc', '$giorno', '$orainizio', $durata, '$codc', '$sala');";
			if(mysqli_query($con, $sql))
				echo "La lezione è stata inserita nel programma dei corsi.<br>";
			else {
				echo '<p style="color:red";><strong>Inserimento non riuscito</strong></p>';
				echo "Non è stato possibile inserire i dati perchè si è verificato il seguente errore: " . mysqli_error($con) . "<br>";
			}
		}
		mysqli_close($con);
	?>

	</br>
	<form method="get" action="Es02_InserimLezione_Q.php">
		<input type="submit" value="Effettua un altro inserimento">
	</form>

</body>
</html>
